#!/usr/bin/env python

import Tkinter, sys, os, string
from pygale import *

XML = """<?xml version="1.0"?>
<fuguconfig>
<preferences>
	<sender>%(sender)s</sender>
	<signer>%(signer)s</signer>
	<buffersize>200</buffersize>
	<jihad on="no" delimiter="/"/>
	<urlcommand>netscape -remote openURL(%%s)</urlcommand>
	<thumbnails on="%(imagecreate)s"/>
	<thumbnail-url></thumbnail-url>
	<ccself on="no"/>
	<autocomplete on="yes"/>
	<broadcast-presence on="yes"/>
	<subject-prompt on="yes"/>
	<cursorcolor>#18ae9e</cursorcolor>
	<buttonbar on="yes"/>
	<presence-list>
		<presence>in/perhaps</presence>
		<presence>out/somewhere/else</presence>
	</presence-list>
	<default-presence>in/perhaps</default-presence>
	<pane-height>700</pane-height>
	<pane-top>500</pane-top>
	<pane-bottom>200</pane-bottom>
	<pane-width>-1</pane-width>
	<save-pane-width on="yes"/>
	<persist-pufflog on="yes" interval="300"/>
</preferences>

<screen>
	<name>Public</name>
	<subscription on="yes">%(publicsub)s</subscription>
	<savehistory on="yes"/>
	<logsent>0</logsent>
	<send-receipts on="no"/>
	<onpuff>
		<beep on="no"/>
		<highlight-button on="yes"/>
		<lift-screen on="no"/>
		<deiconify on="no"/>
		<command on="no"></command>
	</onpuff>
</screen>

<screen>
	<name>Private</name>
	<subscription on="yes">%(privatesub)s</subscription>
	<savehistory on="yes"/>
	<logsent>1</logsent>
	<send-receipts on="yes"/>
	<onpuff>
		<beep on="yes"/>
		<highlight-button on="yes"/>
		<lift-screen on="no"/>
		<deiconify on="no"/>
		<command on="no"></command>
	</onpuff>
</screen>

<screen>
	<name>Watch</name>
	<subscription on="yes">%(watchsub)s</subscription>
	<savehistory on="no"/>
	<logsent>0</logsent>
	<send-receipts on="no"/>
	<onpuff>
		<beep on="no"/>
		<highlight-button on="no"/>
		<lift-screen on="no"/>
		<deiconify on="no"/>
		<command on="no"></command>
	</onpuff>
</screen>

</fuguconfig>"""

# Helper func for config class
def get_my_fullname():
	if sys.platform == 'win32':
		return gale_env.get('GALE_FROM', 'Fugu user')
	else:
		import pwd, string
		name = pwd.getpwuid(os.getuid())[4]
		if "," in name:
			name = name[:string.index(name, ',')]
		if not name:
			name = 'Fugu user'
		return name

def getXML():
	sender = get_my_fullname()
	signer = pygale.gale_user()
	atsign = string.find(signer, '@')
	if atsign != -1:
		domaincat = ':\n@%s/pub' % signer[atsign+1:]
	else:
		domaincat = ''
	publicsub = pygale.gale_env.get('GALE_GSUB', 'pub:local%s' %
		domaincat)
	privatesub = pygale.gale_env.get('GALE_SUBS',
		pygale.id_category(pygale.gale_user(), 'user', ''))
	imagecreate = ['no', 'yes'][hasattr(Tkinter.Text, 'image_create')]
	watchsub = pygale.dom_category(pygale.gale_domain(), 'notice')

	return XML % locals()

