#!/usr/bin/env python

import os, re, socket, sys, string, userinfo

# Defaults go here
NAMESPACE = { }

def conditional_mkdir(dir_name):
	if not os.path.exists(dir_name):
		os.mkdir(dir_name)

SettingsErr = 'SettingsErr'


def init():
	galeconf = os.path.join(NAMESPACE['FUGU_DIR'], 'conf')
	if os.path.exists(galeconf):
		vars = parse_sys_conf(galeconf)
		NAMESPACE.update(vars)
	
	fname = os.path.join(NAMESPACE['FUGU_DIR'], 'pygale.conf')
	if os.path.exists(fname):
		data = open(fname, 'r').readlines()
		for line in data:
			try:
				var, val = string.split(line, None, 1)
			except:
				pass
			else:
				var = string.strip(var)
				val = string.strip(val)
				NAMESPACE[var] = val

def set_fugu_dir():
	# Find the fugu dir
	if os.environ.has_key('FUGU_DIR'):
		fugudir = os.environ['FUGU_DIR']
	else:
		fugudir = os.path.join(userinfo.home_dir, '.gale')
	NAMESPACE['FUGU_DIR'] = fugudir

def load_file(fname):
	data = open(fname, 'r').readlines()
	for line in data:
		var, val = string.split(line, None, 1)
		var = string.strip(var)
		val = string.strip(val)
		NAMESPACE[var] = val

def get(envvar, default=''):
	if os.environ.has_key(envvar):
		return os.environ[envvar]
	
	elif NAMESPACE.has_key(envvar):
		return NAMESPACE[envvar]
	
	else:
		return default


def set(envvar, value):
	NAMESPACE[envvar] = value

	
def get_list(envvar, default=''):
	var = get(envvar, default)
	return re.split('[ ,]*', var)


def has_key(envvar):
	return os.environ.has_key(envvar) or NAMESPACE.has_key(envvar)

def parse_sys_conf(fn):
	data = open(fn, 'r').readlines()
	vars = {}
	lastvar = None
	lastval = None
	for line in data:
		line = string.rstrip(line)
		if not line or line[0] == '#':
			continue
		if line[0] in string.whitespace and lastvar is not None:
			val = string.strip(line)
			if lastval is None:
				lastval = val
			else:
				lastval = lastval + val
		else:
			if lastval is not None:
				# Set variable
				vars[lastvar] = lastval
				lastvar = None
				lastval = None

			ret = string.split(line, None, 1)
			lastvar = ret[0]
			if len(ret) > 1:
				lastval = ret[1]

	if lastval is not None:
		vars[lastvar] = lastval
	
	return vars


set_fugu_dir()
#init()
